;********************************************************************
;             Binary To BCD Conversion Routine
;
;
;
; Ver 1.0                              Coded by Leandro Gentili /1999   
;********************************************************************

BCD     
              bcf     STATUS,C                ; clear the carry bit
  	      movlw   .8
	      movwf   COUNTER1
	      clrf    DECENA
	      clrf    MILENA
loop8         
              rlf     L_BYTE
	      rlf     DECENA
	      rlf     MILENA
;
	      decfsz  COUNTER1
              goto    adjDEC

              movlw .8
              movwf PCLATH
              movf DECENA,w
              movwf TEMP2                
              rrf DECENA
              rrf DECENA
              rrf DECENA
              rrf DECENA,w
              andlw b'00001111'              
              addlw M_NUM-BASE2
              call MORO
              clrf PCLATH
              movwf DIG_2 

              movlw .8
              movwf PCLATH
              movf TEMP2,w
              andlw b'00001111'
              addlw M_NUM-BASE2             
              call MORO 
              clrf PCLATH
              movwf DIG_1

              movlw .8
              movwf PCLATH
              movf MILENA,w           
              andlw b'00001111'
              addlw M_NUM-BASE2
              call MORO
              clrf PCLATH
              movwf DIG_3 

                                  ; Saco los 0s que estan adelante
              movf DIG_3,w
              sublw 0x30
              btfss STATUS,Z
              return

              movlw 0x20
              movwf DIG_3 

              movf DIG_2,w
              sublw 0x30
              btfss STATUS,Z
              return

              movlw 0x20
              movwf DIG_2
              return
;
adjDEC	
              movlw   DECENA
	      movwf   FSR
	      call    adjBCD
;
	      movlw   MILENA
	      movwf   FSR
	      call    adjBCD
;
	      goto    loop8
;
adjBCD  
              movlw   0x03
	      addwf   INDF,w
	      movwf   TEMP1
	      btfsc   TEMP1,3          ; test if result > 7
	      movwf   INDF
	      movlw   0x30
	      addwf   INDF,w
	      movwf   TEMP1
	      btfsc   TEMP1,7         ; test if result > 7
	      movwf   INDF            ; save as MSD
              return




