;********************************************************************
;             Keyboard Routine
;          
;         - Scan Keys Pressed
;
; Ver 1.0                              Coded by Leandro Gentili /1999   
;********************************************************************

RD_KEY
               clrf FLAG_KEY1
               clrf BYTERAM 
               movlw .1
               movwf COUNTER
LOOP22
               movf COUNTER,w
               movwf PORTB
               nop
               nop
               nop
               nop 
               nop
               btfsc PORTA,KEY_IN
               iorwf BYTERAM
               clrf PORTB
               bcf STATUS,C
               rlf COUNTER
               btfss COUNTER,5
               goto LOOP22
               return
;***************************************************************************
;***************************************************************************
PLAY_PRESS                           
               btfss BYTERAM,PLAY
               goto NOAPRE1               
               goto CHE1

NOAPRE1        bcf FLAG_KEY,PLAY
               return
CHE1        
               btfsc FLAG_KEY,PLAY
               return

               bsf FLAG_KEY,PLAY
               bsf FLAG_KEY1,PLAY
               return
;***************************************************************************
;***************************************************************************
REW_PRESS                                         
               btfss BYTERAM,REW
               goto NOAPRE2               
               goto CHE2
NOAPRE2
               btfss FLAG,MANTIENE 
               goto PEPE
	       movlw .15
               movwf CONT1	
PEPE
               bcf FLAG_KEY,REW
               return
CHE2        
               btfss FLAG_KEY,REW
               goto GOMA 
               btfss FLAG,MANTIENE
               return
               decfsz CONT1
               return
               movlw .3
               movwf CONT1
GOMA
               bsf FLAG_KEY,REW
               bsf FLAG_KEY1,REW
               return
;***************************************************************************
;***************************************************************************
FRD_PRESS                           
               btfss BYTERAM,FRD
               goto NOAPRE3               
               goto CHE3
NOAPRE3
               btfss FLAG,MANTIENE 
               goto PEPE2
	       movlw .15
               movwf CONT2	
PEPE2
               bcf FLAG_KEY,FRD
               return
CHE3        
               btfss FLAG_KEY,FRD
               goto GOMA1
               btfss FLAG,MANTIENE
               return
               decfsz CONT2
               return
               movlw .3
               movwf CONT2              
GOMA1
               bsf FLAG_KEY,FRD
               bsf FLAG_KEY1,FRD
               return
;***************************************************************************
;***************************************************************************
STOP_PRESS                           
               btfss BYTERAM,STOP
               goto NOAPRE4               
               goto CHE4

NOAPRE4        bcf FLAG_KEY,STOP
               return
CHE4        
               btfsc FLAG_KEY,STOP
               return

               bsf FLAG_KEY,STOP
               bsf FLAG_KEY1,STOP
               return
;***************************************************************************
;***************************************************************************
MODE_PRESS                           
               btfss BYTERAM,MODE
               goto NOAPRE5               
               goto CHE5

NOAPRE5        bcf FLAG_KEY,MODE
               return
CHE5        
               btfsc FLAG_KEY,MODE
               return

               bsf FLAG_KEY,MODE
               bsf FLAG_KEY1,MODE
               return
;***************************************************************************
;***************************************************************************

