;********************************************************************
;                       Mp3 PuBliC
;                      MP3 CD Player
;
;                                                                
; Ver 1.0                              Coded by Leandro Gentili /1999   
;********************************************************************
                                                                        
	LIST    	p=16C65b,C=132,n=100
;	__CONFIG	_WDT_OFF & _XT_OSC & _PWRTE_ON & _CP_ON & _BODEN_ON 
 ;include	"p16c65b.inc"
 include "p16cxx.inc" 
 include "mp3.inc" 
 include "atapi.asm"
 include "rammove.asm" 
 include "i2s.asm"
 include "bcd.asm"
 include "datacd.asm"       
 include "key.asm" 


;**********************************************************
;        InI Ports 
;**********************************************************
START                                  
              clrf PORTA             
              clrf PORTB
              clrf PORTC
              clrf PORTD
              clrf PORTE

              bsf STATUS,RP0                            

              movlw b'11100111'
              movwf TRISA         
              clrf TRISB
              clrf TRISC     
              clrf TRISD
              clrf TRISE
 
              bcf STATUS,RP0                     
;**********************************************************
;        InI Vars 
;**********************************************************                                                           
              clrf FLAG 
              clrf FLAG_KEY
              clrf FLAG_KEY1
              clrf FLAG_STATE
              clrf FLAG_CD 
              clrf MESSAJE
              clrf MESSAJE1
              clrf CONTROL
              clrf PRE
              movlw 0x08
	      movwf BASS
	      movwf TREBLE
              movlw .9
	      movwf VOLUMEN
;
              call ESPERA
              call ESPERA
              call ESPERA
              call ESPERA
              call ESPERA
;
;**********************************************************
;        InIs 
;**********************************************************        
              movlw RESET_MASDAC    ; Soft start implemented instead
              movwf PORTE
              call ESPERA1
              clrf PORTE	

              movlw 0x08
              movwf PCLATH
              call INI_LCD 
              		clrf PCLATH
NO_ATAPI    
              call INI_ATAPI                                
              
              btfss FLAG,ATAPIn
              goto S_ATAPI

              movlw 0x08
              movwf PCLATH
              call MENSAJE_L1
              		clrf PCLATH
              call ESPERA
              goto NO_ATAPI             
S_ATAPI                          
              bsf MESSAJE,0       ; Muestro "Players Name"           
              movlw 0x08
              movwf PCLATH
              call MENSAJE_L1
              		clrf PCLATH
              call ESPERA     
DENUEVO                                  
              movlw 0x00          ; Borro La Static Ram
              movwf BYTERAM 
              call FULL_BUFFERXX  

              call INI_CD                                                                        

              btfsc FLAG_CD,4
              goto NOCD

              btfss FLAG_CD,6     ; Hybrid espera eject command 
              goto SICD
              btfss FLAG_CD,5
              goto SICD
NOCD                              
              call RD_KEY         ; NO CD Eserar Eject Key  
              call STOP_PRESS
              btfsc FLAG_KEY1,STOP
              goto EJECT_RUTIN
              goto NOCD      
SICD                             
              call SET_MAX_SPEED  ; SI CD seteo La MAX SPEED
              movlw 0x08
              movwf PCLATH
              call NUMERO_SONG    ; Cuantas TRACKs Hay?          
              		clrf PCLATH

              call ESPERA
              call ESPERA
              call ESPERA
              call ESPERA
                           
              movlw .8
              movwf TRANS_1
              movlw 0x40
              movwf TOPE    
              movlw .1
              movwf INDEX
;**********************************************************
;        ThE BiG LoOp
;**********************************************************
LOOP
              bsf FLAG,MANTIENE
              clrf INDEX_LIST     ; Muestro Primer Track 
              movlw 0x08
              movwf PCLATH
              call NAME  
              		clrf PCLATH
LOOPP                            
              call RD_KEY              
              call REW_PRESS
              btfss FLAG_KEY1,REW
              goto NONE
              decfsz INDEX
              goto PUTA
              movf TOTAL_SONG,w
              movwf INDEX            
              goto PUTA
NONE
              call FRD_PRESS
              btfss FLAG_KEY1,FRD
              goto NO_ROTO                  
              incf INDEX                                        
              movf INDEX,w
              subwf TOTAL_SONG,w
              btfsc STATUS,C
              goto PUTA
              movlw .1
              movwf INDEX                            
PUTA
              movlw 0x08
              movwf PCLATH
              call NAME        
              		clrf PCLATH
;******************************************
;******************************************
NO_ROTO      
              call RD_KEY
              call MODE_PRESS 
              btfss FLAG_KEY1,MODE
              goto NO_PRESS
                            
              call CAL_BASE
                                 
              call RD_RAM
                    
              movf BYTERAM,w
              sublw 0x00
              btfss STATUS,Z
              goto DESELECT
SELECT         
              movlw .8
              movwf PCLATH 
              call CURSOR_L2
              		clrf PCLATH

              incf INDEX_LIST
              movf INDEX_LIST,w 

              movwf BYTERAM                           
              call WR_RAM                                          

              goto NO_PRESS                     
;******************************************
;******************************************
DESELECT      
              movlw .8
              movwf PCLATH
              call NO_CURSOR_L2
              		clrf PCLATH

              movf INDEX,w
              movwf TEMP3

              call RD_RAM
                    
              movf BYTERAM,w
              movwf TEMP4
              incf TEMP4
              
              clrf BYTERAM              
              call WR_RAM 
JIRA             
              movlw .1
              movwf INDEX                          
JIRO
              call CAL_BASE
                                 
              call RD_RAM
                    
              movf BYTERAM,w
              subwf TEMP4,w
              btfss STATUS,Z
              goto ORTO
              movf TEMP4,w
              movwf BYTERAM
              decf BYTERAM
              incf TEMP4

              call WR_RAM
              goto JIRA
ORTO
              movf INDEX,w
              subwf TOTAL_SONG,w
              btfsc STATUS,Z
              goto NO_PRE                            
              incf INDEX             
              goto JIRO
NO_PRE
              movf TEMP3,w
              movwf INDEX
              decf INDEX_LIST
 
;******************************************
;******************************************
NO_PRESS                                                                                                                         
              call ESPERA
              call RD_KEY
              call PLAY_PRESS
              btfsc FLAG_KEY1,PLAY
              goto PLAY_RUTIN

              call STOP_PRESS
              btfsc FLAG_KEY1,STOP
              goto EJECT_RUTIN                   

              call ESPERA1
              goto LOOPP
;***************************************************************************
;***************************************************************************
PLAY_RUTIN    
              movlw 0x44          ; CD-Mp3 apago AUX, CD-DA prendo AUX
              btfss FLAG_CD,5     ; Siempre con 5V Dac seleccionado
              movlw 0x4C
              movwf BUFFERIIC+2
              movlw 0x08
              movwf PCLATH
              call INI_DAC
              		clrf PCLATH            

              bcf FLAG,MANTIENE
              call ESPERA                       
              movf INDEX_LIST,w
              sublw 0x00
              btfss STATUS,Z
              goto ADELA
              movf INDEX,w
              movwf TEMP3
              clrf INDEX  
OTRASS         
              incf INDEX_LIST     
              incf INDEX

              call CAL_BASE                       
              movf INDEX_LIST,w
              movwf BYTERAM                      
              call WR_RAM
             
              movf INDEX_LIST,w
              subwf TOTAL_SONG,w
              btfss STATUS,Z
              goto OTRASS              
              movf TEMP3,w
              movwf INDEX_LIST             
              movf TOTAL_SONG,w
              movwf TOTAL_LIST                     
              goto PLAYY
ADELA
              movf INDEX_LIST,w
              movwf TOTAL_LIST 
              movlw .1
              movwf INDEX_LIST                            
              goto PLAYY             
;***************************************************************************
;***************************************************************************
EJECT_RUTIN            
              movlw .2               
              movwf FLAG_CD
              call ST_UNIT
              call ESPERA              
              bsf MESSAJE1,1
              movlw .8
              movwf PCLATH 
              call MENSAJE_L1
              		clrf PCLATH
              call ESPERA1              
              bsf MESSAJE1,2
              movlw .8
              movwf PCLATH
              call MENSAJE_L2
              		clrf PCLATH
              call ESPERA1
MIRAR
              call RD_KEY
              call STOP_PRESS
              btfss FLAG_KEY1,STOP
              goto MIRAR        

              movlw .3
              movwf FLAG_CD
              call ST_UNIT
              call ESPERA
              bsf MESSAJE1,1
              movlw .8
              movwf PCLATH
              call MENSAJE_L2
              		clrf PCLATH
              call ESPERA1
              goto DENUEVO              
;***************************************************************************
;***************************************************************************
PLAY_RUTIN1  
              btfss FLAG_STATE,REW
              goto HENNA
              incfsz CONT1
              goto HENNA
              incfsz CONT2
              goto HENNA
              bcf FLAG_STATE,REW
              goto PLAYY
HENNA
              btfss FLAG_STATE,FRD
              goto HENNA1
              incfsz CONT1
              goto HENNA1
              incfsz CONT2
              goto HENNA1
              bcf FLAG_STATE,FRD
              goto PLAYY
HENNA1
              btfss FLAG_STATE,MODE
              goto HENNA2
              btfsc FLAG_STATE,PAUSE
              call ESPERA11 
              incfsz CONT1
              goto HENNA2
              incfsz CONT2
              goto HENNA2
              movlw .8
              movwf PCLATH
              call TRACK_MENU  
              		clrf PCLATH
              goto ESPECIAL
;************************************
;************************************
HENNA2
              call RD_KEY

              call PLAY_PRESS        
              btfsc FLAG_KEY1,PLAY
              goto RUT_PLAY
              call STOP_PRESS
              btfsc FLAG_KEY1,STOP
              goto RUT_STOP
              call MODE_PRESS
              btfss FLAG_KEY1,MODE
              goto HHHH
              incf CONTROL
              bsf FLAG_STATE,MODE
              movlw 0x08
              movwf PCLATH
              call MOSTRAR_CONTROL
              		clrf PCLATH
              goto ESPECIAL
HHHH
              btfss FLAG_STATE,MODE
              goto NORMAL     
              movlw .8
              movwf PCLATH
              call CONTROLS
              		clrf PCLATH
              goto ESPECIAL
NORMAL                  
              call REW_PRESS
              btfsc FLAG_KEY1,REW
              goto RUT_REW
              call FRD_PRESS
              btfsc FLAG_KEY1,FRD
              goto RUT_FWD    
ESPECIAL                  
              btfsc FLAG_STATE,PAUSE
              goto PLAY_RUTIN1
              btfsc FLAG_STATE,FRD
              goto PLAY_RUTIN1
              btfsc FLAG_STATE,REW
              goto PLAY_RUTIN1

              btfss FLAG_CD,5
              goto AUDII
              goto DEMAND
AUDII                                   
              call READ_SUB

              movf TEMP1,w
              sublw 0x13
              btfss STATUS,Z
              goto PLAY_RUTIN1

              goto RUT_FWD                               
;***********************************************************************
;***********************************************************************                                
RUT_PLAY                     
              btfsc FLAG_STATE,PAUSE
              goto UNPAUSE
               
              btfss FLAG_CD,5
              goto MUSIC
              bsf FLAG_STATE,PAUSE
              goto PLAY_RUTIN1
MUSIC
              bsf FLAG_STATE,PAUSE             
              bcf FLAG_CD,3
              call PAUSE_RESUME                
              call ESPERA
              movlw 0x44
              movwf BUFFERIIC+2
              movlw 0x08
              movwf PCLATH
              call INI_DAC
              		clrf PCLATH
              goto PLAY_RUTIN1
;*******************************************
;*******************************************
UNPAUSE
              btfss FLAG_CD,5
              goto MUSIC1
              bcf FLAG_STATE,PAUSE 
              goto PLAY_RUTIN1
MUSIC1
              movlw 0x4C
              movwf BUFFERIIC+2
              movlw 0x08
              movwf PCLATH
              call INI_DAC
              		clrf PCLATH
              bcf FLAG_STATE,PAUSE     
              bsf FLAG_CD,3
              call PAUSE_RESUME             
              call ESPERA
              goto PLAY_RUTIN1
;***********************************************************************
;***********************************************************************
PLAYY                                                            
              clrf INDEX              
OTRAS               
              incfsz INDEX
              goto NOCERO             
              movlw .1
              movwf INDEX_LIST 
              goto OTRAS
NOCERO
              call CAL_BASE
          
              call RD_RAM

              movf BYTERAM,w
              subwf INDEX_LIST,w
              btfss STATUS,Z
              goto OTRAS                            
;;;
              movlw 0x08
              movwf PCLATH
              call NAME
              call NO_CURSOR_L2            
              		clrf PCLATH
;;;                             
              btfsc FLAG_STATE,FRD
              goto PLAY_RUTIN1
              btfsc FLAG_STATE,REW
              goto PLAY_RUTIN1

              call CAL_BASE

              btfss FLAG_CD,5
              goto PLAY_DA 
;*******************************************
;*******************************************
PLAY_MP3                               
              bcf FLAG,FINALMP3
              bcf FLAG,FINALMP31
       
              movlw .4
              movwf COUNTER
              movlw LBA_1  
              movwf FSR
MN1
              incfsz ADR_RL
              goto JK1
              incf ADR_RH
JK1
              call RD_RAM
              movf BYTERAM,w
              movwf INDF

              incf FSR
              decfsz COUNTER              
              goto MN1

              movlw .4
              movwf COUNTER
              movlw BASEF  
              movwf FSR
MN2
              incfsz ADR_RL
              goto JK2
              incf ADR_RH
JK2
              call RD_RAM
              movf BYTERAM,w
              movwf INDF

              incf FSR
              decfsz COUNTER              
              goto MN2               

              movlw 0x40
              subwf BASEF+1
              btfsc STATUS,C
              goto SIGUE1
              movlw .1
              subwf BASEF+2
              btfss STATUS,C
              subwf BASEF+3
SIGUE1                           
              call ESPERA

              call READ10
              call RD_STATUS_A
              call ST2               
              call FULL_BUFFER

              call ESPERA
                            
              bsf FLAG,MARCA1
              bsf FLAG,MARCA2             
DEM_RUTIN     
              movlw 0xFF
              movwf ADR_RL
              movwf ADR_RH
              clrf ADR_WL
              clrf ADR_WH                                     
DEMAND       
              btfsc PORTA,DEM     ; Si DEM pin =1 MANDA un BYTE         
              goto GATA
          
              btfsc FLAG,MARCA2
              goto DEMAND

              bsf FLAG,MARCA2              

              btfss FLAG,MARCA1
              goto PLAY_RUTIN1
 
              bcf FLAG,MARCA1
                         
              movlw 0x40
              subwf BASEF+1
              btfsc STATUS,C
              goto SIGUE
              movlw .1
              subwf BASEF+2
              btfsc STATUS,C
              goto SIGUE
              subwf BASEF+3
              btfsc STATUS,C
              goto SIGUE

              bsf FLAG,FINALMP3
              movlw 0x40        
              addwf BASEF+1              
SIGUE
              movlw 0x08             
              addwf LBA_1
              btfsc STATUS,C
              incfsz LBA_2
              goto MOMO
              incfsz LBA_3
              goto MOMO
              incf LBA_4
MOMO                                                     
              call RD_STATUS       
              movf STATUS_R,W      
              andlw b'10001000'     
              btfsc STATUS,Z       
              goto PL                      
              call RD_DATA_R
              goto MOMO
PL
              call READ10             
              goto DEMAND                        
GATA
              bcf FLAG,MARCA2
     
              incfsz ADR_RL        
              goto PLACE
	      incf ADR_RH 
PLACE           
              call RD_RAM
              call STREAM

              btfss FLAG,FINALMP31
              goto JIJO
              movf BASEF+1,w
              subwf ADR_RH,w
              btfss STATUS,Z
              goto JIJO
              goto RUT_FWD 
JIJO            
              movlw 0x20
	      subwf ADR_RH,w
              btfss STATUS,C
              goto DEMAND         ; < 8k                               
;**********************
;**********************
              call RD_DATA_R      ; > 8k 
              movf DATA_RL,w
              movwf BYTERAM
	      
              call WR_RAM

              incfsz ADR_WL
              goto ETIQUE
              incf ADR_WH
ETIQUE         
              movf DATA_RH,w
              movwf BYTERAM
              
              call WR_RAM
;**********************
;**********************
              incfsz ADR_WL
              goto JAMER
              incf ADR_WH                           
JAMER      
              movlw 0x3F
              subwf ADR_RH,w
              btfss STATUS,Z
              goto DEMAND 

              movlw 0xFF
              subwf ADR_RL,w
              btfss STATUS,Z
              goto DEMAND 

              btfsc FLAG,FINALMP3
              goto FINALL
               
              bsf FLAG,MARCA1
              bsf FLAG,MARCA2
              goto DEM_RUTIN
FINALL
              bsf FLAG,FINALMP31
              goto DEM_RUTIN
;*******************************************
;*******************************************
PLAY_DA             
              incfsz ADR_RL
              goto KOLO
              incf ADR_RH
KOLO
              call RD_RAM
              movf BYTERAM,w
              movwf START_M
                 
              incfsz ADR_RL
              goto KOLO1
              incf ADR_RH
KOLO1
              call RD_RAM
              movf BYTERAM,w
              movwf START_S

              incfsz ADR_RL
              goto KOLO2
              incf ADR_RH
KOLO2
              call RD_RAM
              movf BYTERAM,w
              movwf START_F
       
              incf INDEX
              call CAL_BASE
              decf INDEX 

              incfsz ADR_RL
              goto KOLO3
              incf ADR_RH
KOLO3        
              call RD_RAM
              movf BYTERAM,w
              movwf END_M
                 
              incfsz ADR_RL
              goto KOLO4
              incf ADR_RH
KOLO4
              call RD_RAM
              movf BYTERAM,w
              movwf END_S

              incfsz ADR_RL
              goto KOLO5
              incf ADR_RH
KOLO5
              call RD_RAM
              movf BYTERAM,w
              movwf END_F               
                                        
              call PLAY_AUDIO_MSF
              call ESPERA
              goto PLAY_RUTIN1 
;***********************************************************************
;***********************************************************************
RUT_REW       
              clrf CONT1
              movlw .225
              movwf CONT2
ST_11                               
              call RD_STATUS       
              movf STATUS_R,W      
              andlw b'10001000'     
              btfsc STATUS,Z       
              goto PL1                      
              call RD_DATA_R
              goto ST_11
PL1
              btfss FLAG_STATE,REW
              goto NUEVVA
              
              decfsz INDEX_LIST
              goto PLAYY
              movf TOTAL_LIST,w
              movwf INDEX_LIST                  
              goto PLAYY                                               
NUEVVA
              bsf FLAG_STATE,REW
              goto PLAYY                 
;***********************************************************************
;***********************************************************************
RUT_FWD      
              clrf CONT1
              movlw .225
              movwf CONT2           
              incf INDEX_LIST                                                                  
ST_12                               
              call RD_STATUS       
              movf STATUS_R,W      
              andlw b'10001000'     
              btfsc STATUS,Z       
              goto PL2                      
              call RD_DATA_R
              goto ST_12     
PL2
              bsf FLAG_STATE,FRD
              goto PLAYY                
;***********************************************************************
;***********************************************************************
RUT_STOP      
              movf INDEX,w
              movwf TEMP3
              movlw .1
              movwf INDEX
              clrf BYTERAM
PONGO0
              call CAL_BASE
              call WR_RAM
              incfsz INDEX
              goto PONGO0                

              movf TEMP3,w
              movwf INDEX
              
              clrf CONTROL
              bcf FLAG_STATE,MODE

              btfss FLAG_CD,5
              goto MUSIC2
ST_13                              
              call RD_STATUS       
              movf STATUS_R,W      
              andlw b'10001000'     
              btfsc STATUS,Z       
              goto LOOP                      
              call RD_DATA_R
              goto ST_13     
MUSIC2        
              movlw 0x44
              movwf BUFFERIIC+2
              movlw 0x08
              movwf PCLATH
              call INI_DAC
              		clrf PCLATH
              bcf FLAG_CD,0
              bcf FLAG_CD,1        
              call ST_UNIT
              call ESPERA             
              goto LOOP              
;**********************************************************
;        DeLaYs
;**********************************************************                          
ESPERA11   
              btfss FLAG_CD,5
              goto DAD                      
              movlw .255
              movwf ACC1
              movlw .40
              movwf ACC2
              goto L1
DAD
              movlw .200
              movwf ACC1
              movlw .4
              movwf ACC2
              goto L1
ESPERA    
              movlw .255
              movwf ACC1
              movwf ACC2
              goto L1
ESPERA1   
              movlw .40        
              movwf ACC2
              movlw .1
              movwf ACC2
L1                      
              nop                 ; Aprox. 1 MicroSec.
              nop
              decfsz ACC1
              goto L1
              decfsz ACC2
              goto L1
              return
;**********************************************************         
;**********************************************************
              org PAGE1
 include "lcd.asm"
 include "i2c.asm"
;**********************************************************         
;**********************************************************
              END
